# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta
# Launcher
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urllib
import base64
import os
import binascii

from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
from core import config
from core import wiideoteca
from core.item import Item
from core import platform_name
from core import scrapertools
import logging.config
import logging
logging.config.fileConfig("logging.conf")
logger=logging.getLogger("wiimc")


def get_content_type():
    return "text/html; charset=UTF-8"

#Sección encargada de recibir la petición http y procesar los datos
def controller(plugin_name,port,host,path,headers):
    itemlist = []
    respuesta = ""
    
    # Menú principal 
    if path == "/"+platform_name.PLATFORM_NAME+"/" or path=="/"+platform_name.PLATFORM_NAME:
        import channelselector
        channelslist = channelselector.getmainlist()
        
        # Actualización automática de canales, actualiza la lista
        if config.get_setting("updatechannels")=="true": itemlist.extend(ActualizarCanal("channelselector","¡Lista de canales actualizada¡"))
        for channel in channelslist:
            # Quita el canal de ayuda, no sirve
            if channel.channel!="ayuda":
                itemlist.append( Item(title=channel.title, url="http://"+host+"/"+platform_name.PLATFORM_NAME+"/"+base64.b64encode(channel.serialize()).replace("/","%2F"),thumbnail=channel.thumbnail, plot=channel.plot) )
        
        Accion, Mensaje, Html = ConstruirHTML(itemlist, True)
        Cache=False
        respuesta = Html

        
    #Resto de Menús
    else:
        #Se crea el Item desde la URL
        item = extract_item_from_url(path)
        #Se crea el nuevo Itemlist
        itemlist, Cache = getitems(item)
        #Item para volver atrás
        itemlist.insert(0, Item(title="Atrás...", url="back", thumbnail="https://docs.google.com/uc?export=download&id=0ByPRdOXQijFBdlBSOC14c3dCT1U") )
        #Se Pasa el Itemlist a HTML
        Accion, Mensaje, Html = ConstruirHTML(itemlist, False)
        
        if item.fulltitle: item.title=item.fulltitle
                
        respuesta = Accion + "|" + Mensaje + "|" + item.title +"|"+ str(Cache) + "|" + base64.b64encode(Html)       
        logger.info (respuesta)    
    return respuesta
    
#Seccion encargada de ejecutar el Item y devolver el resultado    
def getitems(item):
    logger.info("getitems")
    itemlist = []
    Cache=False
      
    #Compruba si hay actualización del canal
    if item.action=="mainlist" and config.get_setting("updatechannels")=="true": itemlist.extend(ActualizarCanal(item.channel,"¡Canal descargado y actualizado!"))

    #Extrae el refered_item en caso de que exista. ¿Para que esto?
    if "|" in item.url:
        partes = urllib.unquote_plus(item.url).split("|")
        refered_item = Item(title=partes[0],url=partes[2],thumbnail="",server=partes[1],plot="",extra=partes[3])
        logger.info( "refered_item title="+refered_item.title+", url="+refered_item.url+", server="+refered_item.server+", extra="+refered_item.extra)
    else:
        refered_item = Item()


    # Importa el canal y ejecuta la función
    channelmodule = ImportarCanal(item.channel)
    
    #Funciones para "channelselector"
    if item.channel=="channelselector":
      import channelselector
      if item.action=="channeltypes":
        itemlist.extend(channelselector.getchanneltypes())

      if item.action=="listchannels":
        channelslist = channelselector.filterchannels(item.category)
        for channel in channelslist:
          channel.action="mainlist"
          itemlist.append(channel)

    elif item.channel=="configuracion":
      if item.action=="mainlist":
        itemlist.extend(menuconfiguracion())
      if item.action=="guardar":
        url = base64.b64decode(item.url)
        Items = url.split("|")
        for conf in Items:
          dato = conf.split("=")
          if len(dato) == 2:
            nombre=conf.split("=")[0]
            valor= conf.split("=")[1]
          else:
            nombre=conf.split("=")[0]
            valor= ""
          logger.info("Nuevo Ajuste: "+ nombre + "=" + valor)
          config.set_setting(nombre, valor )
          itemlist.append(Item(channel="launcher", action="refresh", title=""))

    # play - es el menú de reproducción de un vídeo
    elif item.action=="play":
        logger.info("ACCION PLAY")
        if hasattr(channelmodule, 'play'):
            logger.info("[launcher.py] executing channel 'play' method")
            logger.info(channelmodule.__file__)
            itemlist = channelmodule.play(item)
        else:
            logger.info("[launcher.py] no channel 'play' method, executing core method")
            itemlist.append(item)
        if len(itemlist)>0:    
          itemlist[0].fulltitle=item.title
          itemlist = menu_video(itemlist[0])
        else:
          itemlist.append(Item(title="No hay nada que reproducir", action="alert", channel="launcher"))
        
    elif item.action=="play_video_vlc":
        logger.info("Accion: play_video_vlc url: "+item.url)
        item.channel="launcher"
        itemlist.append(item)
        
    elif item.action=="play_video_html":
        logger.info("Accion: play_video_html url: "+item.url)
        item.channel="launcher"
        itemlist.append(item)

    elif item.action=="search":
        logger.info("ACCION SEARCH")
        itemlist = channelmodule.search(item, item.extra)
        Cache = True
    elif item.action=="por_tecleado":
        itemlist = channelmodule.por_tecleado(item)
        Cache = True
        
    # findvideos - debe encontrar videos reproducibles
    elif item.action=="findvideos":
        logger.info("ACCION FINDVIDEOS")
        if hasattr(channelmodule, 'findvideos'):
            logger.info("[launcher.py] executing channel 'findvideos' method")
            logger.info(channelmodule.__file__)
            itemlist = channelmodule.findvideos(item)
        else:
            logger.info("[launcher.py] no channel 'findvideos' method, executing core method")
            itemlist = findvideos(item,item.channel)
           
    elif item.action=="descargar":
        itemlist = download_item(item,refered_item)
    elif item.action=="download_all":
        itemlist = download_all(item,refered_item)
    elif item.action=="add_to_favorites":
        itemlist = add_to_favorites(item,refered_item)
    elif item.action=="remove_from_favorites":
        itemlist = remove_from_favorites(item,refered_item)
    elif item.action=="add_to_downloads":
        itemlist = add_to_downloads(item,refered_item)
    elif item.action=="remove_from_downloads":
        itemlist = remove_from_downloads(item,refered_item)

    elif item.action=="remove_from_error_downloads":
        itemlist = remove_from_error_downloads(item,refered_item)
    elif item.action=="add_again_to_downloads":
        itemlist = add_again_to_downloads(item,refered_item)
    elif item.action=="send_to_jdownloader":
        itemlist = send_to_jdownloader(item,refered_item)
    elif item.action=="search_trailer":
        itemlist = search_trailer(item,refered_item)
    elif item.action=="add_serie_to_wiideoteca":
        itemlist = wiideoteca.AgregarSerie(item)
    elif item.action=="UltimoVisto":
        itemlist = wiideoteca.UltimoVisto(item)

    # Todas las demas Funciones
    else:
      exec "itemlist.extend( channelmodule."+item.action+"(item))"

    #Pasa los items serializados a la URL para enviarlos al Navegador
    for x, item in enumerate(itemlist):
      if item.channel <> "launcher":
        itemlist[x].url = platform_name.PLATFORM_NAME+"/"+base64.b64encode(item.serialize()).replace("/","%2F")
      if item.thumbnail =="":
        if item.folder:
            itemlist[x].thumbnail = "http://pelisalacarta.mimediacenter.info/squares/folder.png"
        else:
            itemlist[x].thumbnail = "http://pelisalacarta.mimediacenter.info/squares/file.png"
    
    logger.info("Items devueltos")  
    for item in itemlist:
        logger.info( " " + item.title + " | " + item.url + " | " + item.channel + " | " + item.action)
    return itemlist, Cache


#Sección encargada de Construir el código HTML a partir del Itemlist
def ConstruirHTML(itemlist, Home=False):
  Html=""
  Accion = "itemlist"
  Mensaje = ""
  
  # Lee las plantillas
  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "page.html") )
  plantilla_pagina = file_plantilla.read()
  file_plantilla.close()
  
  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "buscar.html") )
  plantilla_buscar = file_plantilla.read()
  file_plantilla.close()  
    
  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "item.html") )
  plantilla_item = file_plantilla.read()
  file_plantilla.close()
  
  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "item_menu.html") )
  plantilla_item_menu = file_plantilla.read()
  file_plantilla.close()

  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "menu.html") )
  plantilla_menu = file_plantilla.read()
  file_plantilla.close()
  
  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "play_video_vlc.html") )
  plantilla_pc = file_plantilla.read()
  file_plantilla.close()

  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "play_video_html.html") )
  plantilla_dispositivo = file_plantilla.read()
  file_plantilla.close()
  
  file_plantilla = open( os.path.join( config.get_runtime_path() , "platformcode" , "mediaserver" , "template" , "config.html") )
  plantilla_config = file_plantilla.read()
  file_plantilla.close()
  
  itemlist_string = ""
  
   
  #Crea el código HTML para los Items
  for item in itemlist:
  
    #Funciones "launcher" no devuelve ningun item, solo un comando para que el cliente realice una funcion (mostrar un alert, refrescar la página, etc...)
    if item.channel=="launcher":
      if item.action =="play_video":
        item_string = plantilla_item
        item_string = item_string.replace("{$title}",item.title)
        item_string = item_string.replace("{$function}","")
        item_string = item_string.replace("{$url}",item.url)
        item_string = item_string.replace("{$thumbnail}",item.thumbnail)
        item_string = item_string.replace("{$plot}",scrapertools.htmlclean(item.plot))
        itemlist_string = itemlist_string+item_string+"\n"
        
      elif item.action =="play_video_vlc":
        item_string = plantilla_pc
        item_string = item_string.replace("{$title}",item.fulltitle)
        item_string = item_string.replace("{$url}",item.url)
        item_string = item_string.replace("{$plot}",item.plot)
        itemlist_string = itemlist_string+item_string+"\n"
      
      elif item.action =="play_video_html":
        item_string = plantilla_dispositivo
        item_string = item_string.replace("{$title}",item.fulltitle)
        item_string = item_string.replace("{$url}",item.url)
        item_string = item_string.replace("{$plot}",item.plot)
        itemlist_string = itemlist_string+item_string+"\n"
      
      else:
        Accion = item.action
        Mensaje = item.title
        break
                
    #Canal Configuración: Crea el código HTML para el canal configuración, ya que las caracteristicas de este son diferente de los otros
    elif item.channel=="configuracion":
      item_string = plantilla_config
      item_string = item_string.replace("{$title}",item.title)
      if item.type =="text":
        item_string = item_string.replace("{$control}","<input type='text' id='"+ item.action +"' value=" + config.get_setting(item.action)+">")
      if item.type =="password":
        item_string = item_string.replace("{$control}","<input type='password' id='"+ item.action +"' value=" + config.get_setting(item.action)+">")
      if item.type =="checkbox":
        item_string = item_string.replace("{$control}","<input type='checkbox' id='"+ item.action +"' " + checked_unchecked(config.get_setting(item.action))+">")
      if item.type =="select":
        Opciones =""
        for x, Opcion in enumerate(item.extra.split("|")):
          Opciones = Opciones + "<option " + selected(x,config.get_setting(item.action)) + ">" + Opcion + "</option>"
        item_string = item_string.replace("{$control}","<select type='text' id='"+ item.action +"'>" + Opciones)
      if item.type =="button":
        item_string = item_string.replace("{$control}","<input type='button' value='"+ item.title +"' OnClick=\"GuardarConfig('"+item.url+"')\">")
        
      itemlist_string = itemlist_string+item_string+"\n"

    #Crea el código HTML para la accion "search" para que muestre un textbox
    elif item.action=="search":
      item_string = plantilla_buscar
      item_string = item_string.replace("{$title}",item.title)
      item_string = item_string.replace("{$function}","OnClick=\"buscar('"+ item.url + "')\"")
      item_string = item_string.replace("{$thumbnail}",item.thumbnail)
      itemlist_string = itemlist_string+item_string+"\n"

    elif item.context<>"":
      menuitemlist_string=""
      for menuitem in item.context.split("|"):
        if menuitem:
          Menu = extract_item_from_url("/"+ item.url)
          Menu.action =menuitem.split(",")[1]
          Menu.url = platform_name.PLATFORM_NAME+"/"+base64.b64encode(Menu.serialize()).replace("/","%2F")

          menuitem_string = plantilla_menu
          menuitem_string = menuitem_string.replace("{$title}",menuitem.split(",")[0])
          menuitem_string = menuitem_string.replace("{$function}","onclick=\"DescargarContenido('"+ Menu.url +"')\"")   
          menuitemlist_string = menuitemlist_string+menuitem_string+"\n"
    
      import random, string
      id = ''.join(random.choice(string.ascii_uppercase + string.digits) for _ in range(10))  
      item_string = plantilla_item_menu
      item_string = item_string.replace("{$menuitemlist}",menuitemlist_string)
      item_string = item_string.replace("{$menuid}",id)
      item_string = item_string.replace("{$title}",item.title)
      item_string = item_string.replace("{$function}","onclick=\"DescargarContenido('"+ item.url +"')\"")
      item_string = item_string.replace("{$url}","#")
      item_string = item_string.replace("{$thumbnail}",item.thumbnail)
      item_string = item_string.replace("{$plot}",scrapertools.htmlclean(item.plot))
      itemlist_string = itemlist_string+item_string+"\n"
   
     
    #Crea el código HTML para el resto de items
    else:
      item_string = plantilla_item
      item_string = item_string.replace("{$title}",item.title)
      item_string = item_string.replace("{$function}","onclick=\"DescargarContenido('"+ item.url +"')\"")
      item_string = item_string.replace("{$url}","#")
      item_string = item_string.replace("{$thumbnail}",item.thumbnail)
      item_string = item_string.replace("{$plot}",scrapertools.htmlclean(item.plot))
      itemlist_string = itemlist_string+item_string+"\n"
  
  #Crea el código HTML para la Página Principal    
  if Home:
    Html = plantilla_pagina.replace("{$page-title}","Pelisalacarta")
    Html = Html.replace("{$itemlist}",itemlist_string)
  else:
    Html = itemlist_string
  return Accion, Mensaje, Html

#Sección encargada de comprobar las actualizaciones de los canales
def ActualizarCanal(channel, Texto="Actualizado con exíto"):
  itemlist=[]
  try:
    logger.info("Verificando actualización de: " + channel)
    from core import updater
    actualizado = updater.updatechannel(channel)
    if actualizado:
      itemlist.append( Item(title=Texto, channel=channel, thumbnail="http://pelisalacarta.mimediacenter.info/squares/Crystal_Clear_action_info.png"))
  except:
      import sys
      for line in sys.exc_info():
          logger.error( "%s" % line )
  return itemlist

#Sección encargada de importar los canales
def ImportarCanal(channel):
  channelmodule=""
  try:
    exec "from pelisalacarta.channels import "+channel+" as channelmodule"
  except:
    import sys
    for line in sys.exc_info():
      logger.error( "%s" % line )
    try:
      exec "from pelisalacarta import "+channel+" as channelmodule"
    except:
      import sys
      for line in sys.exc_info():
        logger.error( "%s" % line )
      try:
        exec "from core import "+channel+" as channelmodule"
      except:
        pass
  return channelmodule
  
#Sección encargada de crear el menú de configuración                    
def menuconfiguracion():
    itemlist =[]
    
    itemlist.append(Item(channel = "configuracion", title="Puerto"                         , action="server.port"           , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Comprobar actualizaciones"      , action="updatecheck2"          , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Actualizar automaticamente"     , action="updatechannels"        , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Modo adultos"                   , action="enableadultmode"       , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Depuracion"                     , action="debug"                 , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Accion por defecto"             , action="default_action"        , type="select"   , extra="Preguntar|Ver|Ver en calidad alta|Enviar a Jdownloader" ))
    itemlist.append(Item(channel = "configuracion", title="Modo de thumbnails"             , action="thumbnail_type"        , type="select"   , extra="Poster|Banner|Cuadrado" ))
    itemlist.append(Item(channel = "configuracion", title="Filtro de Idioma"               , action="languagefilter"        , type="select"   , extra="Cualquier idioma|Español|Ingles|Italiano|Portuges|Catalan|Euskera|Gallego|Valenciano" ))
    itemlist.append(Item(channel = "configuracion", title="Directorio de descargas"        , action="downloadpath"          , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Directorio de favoritos"        , action="bookmarkpath"          , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Direccion jDownloader"          , action="jdownloader"           , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Numero de Busquedas a guardar"  , action="limite_busquedas"      , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Servidor de descargas pyLoad"   , action="pyloadr"               , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Ruta de descargas pyLoad"       , action="pyload_downloads"      , type="text" ))
    

    itemlist.append(Item(channel = "configuracion", title="Usar Real Debrid"               , action="realdebridpremium"     , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Real Debrid user"               , action="realdebriduser"        , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Real Debrid password"           , action="realdebridpassword"    , type="password" ))

    itemlist.append(Item(channel = "configuracion", title="Usar Alldebrid"                 , action="alldebridpremium"      , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Alldebrid user"                 , action="alldebriduser"         , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Alldebrid password"             , action="alldebridpassword"     , type="password" ))

    itemlist.append(Item(channel = "configuracion", title="Cuenta Pordede"                 , action="pordedeaccount"        , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Pordede user"                   , action="pordedeuser"           , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Pordede password"               , action="pordedepassword"       , type="password" ))

    itemlist.append(Item(channel = "configuracion", title="Cuenta Quebajamos"              , action="quebajamosaccount"     , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Quebajamos user"                , action="quebajamosuser"        , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Quebajamos password"            , action="quebajamospassword"    , type="password" ))

    itemlist.append(Item(channel = "configuracion", title="Cuenta Seriesmu"               , action="seriesmuaccount"        , type="checkbox" ))
    itemlist.append(Item(channel = "configuracion", title="Seriesmu user"                 , action="seriesmuuser"           , type="text" ))
    itemlist.append(Item(channel = "configuracion", title="Seriesmu password"             , action="seriesmupassword"       , type="password" ))

   
    itemlist.append(Item(channel = "configuracion", title="Guardar"                        , action=""                      , type="button" ))

    return itemlist

  
#Sección encargada de pasar la URL a un Item
def extract_item_from_url(requestpath):
    logger.info("extract_item_from_url()")
    # La ruta empleada en la petición
    ruta = requestpath.split("?")[0]
    logger.info("ruta="+ruta)

    # El item serializado está codificado en base64
    itemserializado = ruta.split("/")[2]
    itemserializado = itemserializado.replace("%2F","/")
    itemserializado = itemserializado.replace("%2f","/")
    logger.info("item base64="+itemserializado)
    import base64
    item = Item()
    item.deserialize(base64.b64decode(itemserializado))
    logger.info("item: channel="+item.channel+", action="+item.action+", title="+item.title+", url="+item.url+", server="+item.server+", category="+item.category)
    return item

def checked_unchecked(valor):
  if valor=="true":
    return "Checked=true"
  else:
    return ""

def selected(item, valor):

  if int(valor)==item:
    return "selected=selected"
  else:
    return ""
    
def download_item(item,refered_item):
    itemlist = []
    # Extrae todos los enlaces posibles
    exec "from servers import "+refered_item.server+" as server_connector"
    video_urls = server_connector.get_video_url( page_url=refered_item.url , premium=(config.get_setting("megavideopremium")=="true") , user=config.get_setting("megavideouser") , password=config.get_setting("megavideopassword") )
    if len(video_urls)>0:
      from core import downloadtools
      titulo = item.fulltitle
      if titulo=="": titulo=refered_item.title
      downloadtools.downloadtitle(video_urls[len(video_urls)-1][1],titulo)
      itemlist.append( Item(channel="launcher", action="alert", title="Descarga finalizada"))
    else:
      itemlist.append( Item(channel="launcher", action="alert", title="El video ya no está disponible"))
    return itemlist

def send_to_jdownloader(item,refered_item):
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="Opción no disponible"))

def add_to_favorites(item,refered_item):
    from core import favoritos
    favoritos.savebookmark(titulo=refered_item.title,url=refered_item.url,thumbnail="",server=refered_item.server,fulltitle=item.fulltitle,plot="")
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="El video "+refered_item.title+"\nha sido añadido a favoritos"))
    return itemlist

def remove_from_favorites(item,refered_item):
    from core import favoritos
    favoritos.deletebookmark(refered_item.extra)
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="El video "+refered_item.title+"\nha sido eliminado de favoritos"))
    return itemlist

def download_all(item,refered_item):
    from core import descargas
    descargas.downloadall(item)
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="Fin de todas las descargas pendientes"))
    return itemlist

def add_to_downloads(item,refered_item):
    from core import descargas
    descargas.savebookmark(titulo=refered_item.title,url=refered_item.url,thumbnail="",server=refered_item.server,plot="")
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="El video "+refered_item.title+"\nha sido añadido a la lista\nde descargas"))
    return itemlist

def remove_from_downloads(item,refered_item):
    from core import descargas
    descargas.deletebookmark(refered_item.extra)
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="El video "+refered_item.title+"\nha sido eliminado de la lista\nde descargas"))
    return itemlist

def remove_from_error_downloads(item,refered_item):
    from core import descargas
    descargas.delete_error_bookmark(refered_item.extra)
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="El video "+refered_item.title+"\nha sido eliminado definitivamente"))   
    return itemlist

def add_again_to_downloads(item,refered_item):
    from core import descargas
    descargas.mover_descarga_error_a_pendiente(refered_item.extra)
    itemlist = []
    itemlist.append( Item(channel="launcher", action="alert", title="El video "+refered_item.title+"\nha sido movido a la lista\nde descargas de nuevo"))   
    return itemlist

def menu_video(item):
    itemlist = []
    logger.info("menu_video url="+item.url+", server="+item.server+", fulltitle="+item.fulltitle)

    from servers import servertools
    video_urls,puede,motivo = servertools.resolve_video_urls_for_playing( item.server , item.url , video_password="" , muestra_dialogo=False)

    if puede:
        for video_url in video_urls:
            logger.info(video_url)
            itemlist.append( Item(channel="launcher" , title="Ver "+video_url[0], plot="Abre el vídeo en el reproductor predeterminado", url=video_url[1], action="play_video", folder=False) )
            itemlist.append( Item(channel=item.channel, title="Ver "+video_url[0]+" - [VLC]", plot="Firefox, Chrome, Safari (NO IE). Necesario VLC", url=video_url[1], action="play_video_vlc",fulltitle=item.fulltitle) )
            itemlist.append( Item(channel=item.channel, title="Ver "+video_url[0]+" - [HTML]", plot="iOS, Android. Navegador nativo", url=video_url[1], action="play_video_html",fulltitle=item.fulltitle) )
        
        refered_item_encoded = urllib.quote(item.title.replace("|","-"))+"|"+urllib.quote(item.server)+"|"+urllib.quote(item.url)+"|"+urllib.quote(item.extra)
        
        itemlist.append( Item(channel=item.channel, title="Descargar",action="descargar",url=refered_item_encoded,fulltitle=urllib.quote(item.fulltitle) ) )
        
        if item.channel!="favoritos":
            itemlist.append( Item(channel=item.channel, title="Añadir a favoritos",action="add_to_favorites",url=refered_item_encoded,fulltitle=urllib.quote(item.fulltitle) ) )
        else:
            itemlist.append( Item(channel=item.channel, title="Quitar de favoritos",action="remove_from_favorites",url=refered_item_encoded,fulltitle=urllib.quote(item.fulltitle) ) )
        
        if item.channel!="descargas":
            itemlist.append( Item(channel=item.channel, title="Añadir a la lista de descargas",action="add_to_downloads",url=refered_item_encoded,fulltitle=urllib.quote(item.fulltitle) ) )
        else:
            if item.category=="errores":
                itemlist.append( Item(channel=item.channel, title="Quitar definitivamente de la lista de descargas",action="remove_from_error_downloads",url=refered_item_encoded ) )
                itemlist.append( Item(channel=item.channel, title="Pasar de nuevo a la lista de descargas",action="add_again_to_downloads",url=refered_item_encoded ) )
            else:
                itemlist.append( Item(channel=item.channel, title="Quitar de la lista de descargas",action="remove_from_downloads",url=refered_item_encoded ) )
    
        itemlist.append( Item(channel=item.channel, title="Enviar a jdownloader",action="send_to_jdownloader",url=refered_item_encoded ) )
        itemlist.append( Item(channel=item.channel, title="Buscar trailer",action="search_trailer",url=refered_item_encoded ) )
        if item.category=="wiideoteca":
            itemlist.append( Item(channel=item.channel, title="Marcar como Ultimo Episodio Visto",action="UltimoVisto",url=item.extra,fulltitle=item.fulltitle ) )

    # Si no puedes ver el vídeo te informa
    else:
      if item.server!="":
        itemlist.append( Item(channel="launcher", action="alert", title="No puedes ver ese vídeo porque...\n"+motivo.replace("<br/>","\n")+"\n"+item.url))
      else:
        itemlist.append( Item(channel="launcher", action="alert", title="No puedes ver ese vídeo porque...\nEl servidor donde está alojado no está soportado en pelisalacarta todavía\n"+item.url))
    return itemlist

def findvideos(item,channel):
    logger.info("findvideos")

    url = item.url
    title = item.title
    thumbnail = item.thumbnail
    plot = item.plot
    fulltitle = item.fulltitle
    # Descarga la pagina
    from core import scrapertools
    data = scrapertools.cachePage(url)
    
    from servers import servertools
    listavideos = servertools.findvideos(data)
    
    itemlist = []
    for video in listavideos:
        scrapedtitle = video[0]
        scrapedurl = video[1]
        server = video[2]
        itemlist.append( Item(channel=channel, action="play" , title=scrapedtitle , url=scrapedurl, thumbnail=item.thumbnail, plot=item.plot, server=server, fulltitle=fulltitle, folder=False))

    return itemlist
